model Recharge_BatterieSolaire_Exercice
  Modelica.Electrical.Analog.Basic.Ground groundDC annotation(
    Placement(visible = true, transformation(origin = {-40, -30}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  parameter PhotoVoltaics.Records.SHARP_NU_S5_E3E Data_panneau annotation(
    Placement(visible = true, transformation(extent = {{-80, 32}, {-60, 52}}, rotation = 0)));
  Modelica.Electrical.Analog.Sensors.PowerSensor powerSensor annotation(
    Placement(visible = true, transformation(extent = {{-20, 10}, {0, 30}}, rotation = 0)));
  PhotoVoltaics.Components.SimplePhotoVoltaics.SimpleModuleSymmetric module(T = 298.15, moduleData = Data_panneau, useConstantIrradiance = false) annotation(
    Placement(visible = true, transformation(origin = {-40, 0}, extent = {{-10, 10}, {10, -10}}, rotation = -90)));
  PhotoVoltaics.Sources.Irradiance.Irradiance irradiance(Jprime(fixed = false), dayOfYear(fixed = false), daysOfYear(fixed = false), irradianceRef = 1500, startDayOfYear(fixed = false), year(fixed = false)) annotation(
    Placement(visible = true, transformation(extent = {{-90, -10}, {-70, 10}}, rotation = 0)));
  parameter Modelica.Electrical.Batteries.ParameterRecords.CellData Data_Battery(OCVmax = 12.8, OCVmin = 9.1, Qnom(displayUnit = "C") = 3.2, Ri = 4.2, SOCmax = 1, SOCmin = 0.1) annotation(
    Placement(visible = true, transformation(origin = {28, 40}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Electrical.Batteries.BatteryStacks.CellStack Batterie(SOC(fixed = true, start = 0.1), cellData = Data_Battery) annotation(
    Placement(visible = true, transformation(origin = {80, 0}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
  Modelica.Electrical.Analog.Sources.ConstantCurrent constantCurrent(I = 0.5) annotation(
    Placement(visible = true, transformation(origin = {110, -2}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
equation
  connect(irradiance.irradiance, module.variableIrradiance) annotation(
    Line(points = {{-69, 0}, {-52, 0}}, color = {0, 0, 127}));
  connect(powerSensor.nv, groundDC.p) annotation(
    Line(points = {{-10, 10}, {-10, 10}, {-10, -18}, {-10, -20}, {-40, -20}}, color = {0, 0, 255}));
  connect(powerSensor.pc, powerSensor.pv) annotation(
    Line(points = {{-20, 20}, {-20, 30}, {-10, 30}}, color = {0, 0, 255}));
  connect(groundDC.p, module.n) annotation(
    Line(points = {{-40, -20}, {-40, -10}}, color = {0, 0, 255}));
  connect(module.p, powerSensor.pc) annotation(
    Line(points = {{-40, 10}, {-40, 10}, {-40, 20}, {-20, 20}}, color = {0, 0, 255}));
  connect(Batterie.p, constantCurrent.p) annotation(
    Line(points = {{80, 10}, {80, 24}, {110, 24}, {110, 8}}, color = {0, 0, 255}));
  connect(groundDC.p, constantCurrent.n) annotation(
    Line(points = {{-40, -20}, {110, -20}, {110, -12}}, color = {0, 0, 255}));
  connect(Batterie.n, groundDC.p) annotation(
    Line(points = {{80, -10}, {80, -20}, {-40, -20}}, color = {0, 0, 255}));
  connect(powerSensor.nc, Batterie.p) annotation(
    Line(points = {{0, 20}, {80, 20}, {80, 10}}, color = {0, 0, 255}));
  annotation(
    uses(Modelica(version = "4.0.0"), PhotoVoltaics(version = "2.X.X"), ElectricalEnergyStorage(version = "3.2.2")),
    Diagram(coordinateSystem(extent = {{-100, 60}, {120, -60}})),
    version = "");
end Recharge_BatterieSolaire_Exercice;
